.nolist
useMB=0
if useMB
	include \masm32\MasmBasic\MasmBasic.inc 
else
	include \masm32\include\masm32rt.inc
	.686
	.xmm
endif
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

floatx$ MACRO arg, digitfactor:=<1000>
  fld arg
  push digitfactor
  call floatx
  EXITM <eax>
ENDM

floatnix$ MACRO arg, nosucharg
  push offset arg
  pop eax
  call print_float
  mov eax, offset NullString	; use a dummy - the routine prints itself
  EXITM <eax>
ENDM

CodeSize MACRO algo, mode
  pushad
  mov eax, offset &algo&_endp
  sub eax, offset &algo&_s	; sub eax, offset algo sounds good but no good with symbols!
  print str$(eax), 9, " bytes for &algo&", 13, 10
  popad
ENDM

.data?
NullString	dd ?
flBuffer	db 20 dup(?)

.code
align 16
;r10a	REAL10	123.4567



align 8

selectTest=2

if selectTest eq 1

digitfactor=1000000000
r8a	REAL8	123456789012345678.901234567

elseif selectTest eq 2

digitfactor=1000000000
r8a	REAL8	12345678.901234567

else

digitfactor=10000
r8a	REAL8	123.4567

endif

r8b	REAL8	1234.56
r8c	REAL8	1234567.89012345678
r8d	REAL8	-0.00123456789		; low negative number
r8e	REAL8	1.23456
r8f	REAL8	-123.456	; negative number

r4a	REAL4	12.3456
r4b	REAL4	1234.56
r4c	REAL4	1234567.89012345678
r4d	REAL4	-0.00123456789		; low negative number
r4e	REAL4	1.23456
r4f	REAL4	-123.456	; negative number
sprFormat db "%f", 0

start:
	push 1
	call ShowCpu	; print brand string and SSE level
	RayMod=0	; set to 1 to test it

	ShowTimings=1
	mov ebx, esp
	; CodeSize print_float
	CodeSize floatx
	CodeSize Axprint_float
	
	fld r8a
	push digitfactor
	call floatx
	print eax, "    ", 9, "floatx", 13, 10
	
	invoke FloatToStr, real8 ptr r8a, offset flBuffer
	print offset flBuffer, "    ", 9, "FloatToStr", 13, 10
	if useMB
		void Str$("%6f", r8a)
		print eax, "    ", 9, "MB Str$()", 13, 10
	endif

	invoke crt_sprintf, offset flBuffer, offset sprFormat, r8a
	print offset flBuffer, 9, "crt sprintf", 13, 10
	
	add esp,-128
	mov edx,esp
	push digitfactor
	push "."
	fld r8a
	push edx
	call Axprint_float
	mov edx,esp
	print edx,9,"Axprint_float",13,10
	add esp,128
		
	print chr$(13,10)
	

if ShowTimings
	SleepMs =	50	; test if anything changes when changing this
	LOOP_COUNT =	1000000	; One Mio would be a typical value
	push ebx
	REPEAT 3
	;comment ~
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			fld r8a
			push digitfactor
			call floatx
		counter_end
		print str$(eax), 9, "cycles for floatx", 13, 10
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke FloatToStr, qword ptr r8a, offset flBuffer
		counter_end
		print str$(eax), 9, "cycles for FloatToStr", 13, 10
	if useMB
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			void Str$("%6f", r8a)
		counter_end
		print str$(eax), 9, "cycles for Str$()", 13, 10
	endif
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT/10, HIGH_PRIORITY_CLASS
			invoke crt_sprintf, offset flBuffer, offset sprFormat, r8a
		counter_end
		print str$(eax), 9, "cycles for crt_sprintf", 13, 10
		;~
		
		add esp,-128
		mov edi,esp
		
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			fld r8a
			push digitfactor
			push "."
			push edi			
			call Axprint_float
		counter_end
		
		add esp,128
		
		print str$(eax), 9, "cycles for Axprint_float", 13, 10
		
		
				
		print chr$(13, 10)		
		
		
	ENDM
	pop ebx
else
	print chr$(13,10)
	print "nixeagle float, Ray's mod = "
	print str$(RayMod), ":", 13, 10
	print floatnix$(r8a), 13, 10
	print floatnix$(r8b), 13, 10
	print floatnix$(r8c, 100000000), 13, 10
	print floatnix$(r8d, 10000000), 13, 10
	print floatnix$(r8e), 13, 10
	print floatnix$(r8f), 13, 10, 10

	print "jj float, Real8:", 13, 10
	print floatx$(r8a), 13, 10
	print floatx$(r8b), 13, 10
	print floatx$(r8c, 1000000000), 9, "9 digits set", 13, 10
	print floatx$(r8d, 10000000), 9, "7 digits set", 13, 10
	print floatx$(r8e), 13, 10
	print floatx$(r8f), 13, 10, 10

	print "jj float, Real4:", 13, 10
	print floatx$(r4a), 13, 10
	print floatx$(r4b), 13, 10
	print floatx$(r4c, 1000000000), 9, "9 digits set", 13, 10
	print floatx$(r4d, 10000000), 9, "7 digits set", 13, 10
	print floatx$(r4e), 13, 10
	print floatx$(r4f), 13, 10, 10
endif
	sub ebx, esp
	.if !Zero?
		print chr$(10,10,10, "stack diff=")
		print str$(ebx), 13, 10
	.endif
	inkey chr$(0)
	exit
x1000	REAL4 1000.0
  ; bits		54321098
  MbDown64 =	10000111b
  MbNear64 =	10000011b

floatx_s:
floatx proc 		; arg1=digits
  push edi
  stack equ <dword ptr [esp]>	; example is -123.456
  mov edi, offset flBuffer
  push edi			; save offset flBuffer
  push 256*MbDown64+255	; create a slot with control word
  fstcw word ptr [esp+2]	; save a copy to hiword - the fnstcw version is 5 cycles slower
  fldcw word ptr [esp]	; set new control word
  push edi			; create another slot
  fist stack			; stack=123
  cmp byte ptr [esp+3], 0	; negative REAL8?
  .if Sign?
	fchs	; make ST(0) positive
	fist stack	; save again
	mov al, "-"	; handle a negative number
	stosb
  .endif
  fisub stack		; ST0=0.456
  pop edx
  mov byte ptr [esp+1], MbNear64
  fldcw word ptr [esp]	; set new control word
  invoke dwtoa, edx, edi
  .Repeat
	inc edi
  .Until byte ptr [edi]==0
  push edi			; pBuffer for dwtoa
  push stack[20]	; digits to stack - we need to use a dirty trick here:
  fimul stack		; e.g. for 123.007654  --->  ST0=7.654
  fiadd stack		; ST0=1007.xxx
  fistp stack		; [esp]=arg for dwtoa
  call dwtoa		; invoke dwtoa, digits, edi=pBuffer
  mov byte ptr [edi], "."	; dirty hack: overwrite the leading "1"
  fldcw word ptr [esp+2]	; restore old control word
  pop edx
  pop eax			; return start of buffer
  pop edi
  retn 4
floatx endp
floatx_endp:

;; assume pointer to float is in eax
;; float is REAL8
print_float_s:	; for CodeSize
print_float PROC
    push ebx
    push ecx
    push edx
    fld REAL8 PTR [eax]            ; Load, store as integer, and print
	; Ray
;	int 3
if RayMod
    fist DWORD PTR [esp+4]        ; the integer portion of the number.
    fisub dword ptr[esp+4]        ; ****** leaves only the fractional part on the FPU ******
    mov eax, [esp+4]
    print ustr$(eax)

    print "."                      ; Print decimal point marker.

    mov ebx, 3
  TheLoop:
    mov ecx, 10
    mov [esp+4], ecx
    
    fimul DWORD PTR [esp+4]
    fist DWORD PTR [esp+4]
    fisub dword ptr[esp+4]
    mov edx, [esp+4]
    print ustr$(edx)

    dec ebx
    jnz TheLoop
else
    fist DWORD PTR [esp+4]        ; the integer portion of the number.
    mov eax, [esp+4]
    print ustr$(eax)

    print "."                      ; Print decimal point marker.

    mov ebx, 3
  TheLoop:
    ;;; now prepare to print first 3 digits after the decimal point.
    mov ecx, 10
    mov [esp+4], ecx
    
    fimul DWORD PTR [esp+4]
    fist DWORD PTR [esp+4]
    mov eax, [esp+4]
    mov ecx, 10
    xor edx, edx
    div ecx
    ;; we want remainder, which is in edx.
    print ustr$(edx)

    dec ebx
    jns TheLoop
endif

    fistp DWORD PTR [esp+4]
    pop edx
    pop ecx
    pop ebx
    ret
print_float ENDP
print_float_endp:



align 16
Axprint_float_s:

option prologue:none
option epilogue:none
Axprint_float proc stdcall lpszOutStr:DWORD, chDot:DWORD, digitsAfterDot:DWORD
	
	mov ecx,[esp+4]

	push ebp
	mov ebp,esp
	
	ftst
	fnstsw ax
	xchg eax,ecx
		
	test ch,40h	; test if number passed is zero
	jz @nonzero
	test ch,4	; test if number is NaN
	mov ecx,"NaN"
	jnz @F
	mov ecx,"0.0"
	mov ch,byte ptr [ebp+12]	; get a dot
	@@:
	mov dword ptr [eax],ecx
	leave
	add eax,3	; add length of output string
	ret 12
	
	@nonzero:
	test ch,1	; test if number passed is negative
	jz @numispositive
	mov byte ptr [eax],"-"
	fchs
	inc eax

	@numispositive:
	fld st(0)
	
	fnstcw word ptr [ebp+8]
	mov ecx,[ebp+8]
	or byte ptr [ebp+9],4	; set FPU round down
	add esp,-16
	fldcw word ptr [ebp+8]
	mov [ebp+8],ecx
	and esp,-16
	
		
	frndint
	
	fldcw word ptr [ebp+8]		; restore FPU rounding (usually it is nearest)
			
	fsub st(1),st(0)	; get fractional part
	

	@reloop:
	ftst			; check if the integer/fractional part of the number is zero
	fstsw word ptr [esp]
	test byte ptr [esp+1],40h
	jz @F
	mov byte ptr [eax],"0"
	fstp st(0)
	inc eax
	jmp @zero
	
	@@:

	push 9
	pop edx
	fbstp tbyte ptr [esp]	; convert it to packed BCD
	@@:			; strip all leading zeroes
		dec edx
ifdef useFaster
		cmp byte ptr [esp+edx],0
	jz @B
else
		movzx ecx,byte ptr [esp+edx]
	jecxz @B
endif
	
ifdef useFaster
	movzx ecx,byte ptr [esp+edx]
endif
	test cl,0f0h		; check if the high nibble of the fist byte is a leading zero
	jnz @in1
	add cl,"0"		; then process low nibble
	mov byte ptr [eax],cl
	inc eax
	dec edx
	js @zero

	@mainloop:		; convert BCD into ASCII
	movzx ecx,byte ptr [esp+edx]
	@in1:
		shl ecx,4
		shr cl,4
		add ecx,'00'
		mov byte ptr [eax],ch
		mov byte ptr [eax+1],cl
		inc eax
		inc eax
		dec edx
	jns @mainloop
	
	@zero:
	cmp dword ptr [ebp+16],0	; digitsAfterDot is also a flag: if it is zero, then this was second pass
	jz @done			; i.e. fractional part is processed just now
	
	;##### here also maybe is better to use simple double for higher output precision of fractional part
	fimul dword ptr [ebp+16]
	movzx ecx,byte ptr [ebp+12]
	mov byte ptr [eax],cl
	and dword ptr [ebp+16],0
	inc eax
	jmp @reloop
			
	@done:
	leave
	mov byte ptr [eax],0
	ret 12
	
Axprint_float endp
Axprint_float_endp:

option prologue:prologuedef
option epilogue:epiloguedef



ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp
end start
